<?php
class GenTable {

	private $acl;
	private $title = '';
	private $formStruct = array();
	private $dataOrder = array();

	public function __construct($aclObj,$tblName,$struct)
	{
		$this->acl = $aclObj;
		$this->title = $tblName;
		$this->openForm($struct);
	}
	
	public function openForm($formName)
	{
		$formFile = dirname(__FILE__).'/form.'.$formName.'.php';
		if(file_exists($formFile)){
			include($formFile);
			$this->formStruct = $form;
		}
	}

	private function tblHeading($formStruct)
	{
		$reOrder = array_fill(0,count($formStruct),0);
		$this->dataOrder = array_fill(0,count($formStruct),0);
		$th = '';
		foreach($formStruct as $key=>$def){
			$ord = $def[0];
			$reOrder[$ord] = array($key,$def[1]);
			$this->dataOrder[$ord] = $key;
		}
		foreach($reOrder as $k=>$def){
			$th.= '<th>'.$def[1].'</th>';
		}
		$thead = '<tr>'.$th.'</tr>';
		return $thead;
	}

	private function tblData($data)
	{
		if(count($data)==0){
			return '<tr><td>brak danych</td></tr>';
		}
		$tbody = '';
		foreach($data as $entry){
			$cell = '';
		#	foreach($entry as $cdata){
			foreach($this->dataOrder as $key){
				$cdata = $entry[$key];
				$cell.= '<td>'.$cdata.'</td>';
			}
			$row = '<tr>'.$cell.'</tr>';
			$tbody.= $row;
		}
		return $tbody;
	}

	public function build($data)
	{
		if($this->title!=null){
			$tblCap = '<caption>'.$this->title.'</caption>';
		}
		$thead = $this->tblHeading($this->formStruct);
		$tbody = $this->tblData($data);

		$tbl = '<table>'.$tblCap.$thead.$tbody.'</table>';
		return $tbl;
	}

}
include('firma-krzak.php');
$tbl = new GenTable(null,'Lista uczestników','persons3');
echo $tbl->build($dbData);
